/**
 * Copyright (C) 2009-2012 enStratus Networks Inc
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.flexiscale;

import javax.xml.rpc.ServiceException;
import org.dasein.cloud.CloudErrorType;
import org.dasein.cloud.CloudException;

import com.flexiant.extility.FlexiScaleServiceLocator;
import com.flexiant.extility.FlexiScaleSoapBindingStub;

public class FlexiscaleStub {

	private FlexiscaleProvider  provider =  null;
	
	public FlexiscaleStub(FlexiscaleProvider provider) throws CloudException{		
		this.provider = provider;
	}
	
	public FlexiScaleSoapBindingStub getFlexiscaleStub() throws CloudException{		
		return getFlexiscaleStub(provider);
	}
	
	public FlexiScaleSoapBindingStub getFlexiscaleStub(FlexiscaleProvider provider) throws CloudException{	
		if(provider != null){
			FlexiScaleServiceLocator locator = new FlexiScaleServiceLocator();
			locator.setFlexiScaleEndpointAddress(provider.getURL());		
			FlexiScaleSoapBindingStub service_stub;
			try {
				service_stub = (FlexiScaleSoapBindingStub) locator.getFlexiScale();
				service_stub.setUsername(new String (provider.getContext().getAccessPublic()));
				service_stub.setPassword(new String (provider.getContext().getAccessPrivate()));
				return service_stub;
			} catch (ServiceException e) {
				throw new CloudException(CloudErrorType.GENERAL, 0, null, e.getMessage());		
			}
		}
		return null;
	}	
}
