/**
 * Copyright (C) 2009-2012 enStratus Networks Inc
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.flexiscale.compute;


import org.dasein.cloud.CloudException;
import org.dasein.cloud.compute.AbstractComputeServices;
import org.dasein.cloud.flexiscale.FlexiscaleProvider;

public class FlexiscaleComputeServices extends AbstractComputeServices {
    private FlexiscaleProvider cloud;
    
    public FlexiscaleComputeServices(FlexiscaleProvider cloud) { this.cloud = cloud; }
    
    
    @Override
    public FlexiscaleImage getImageSupport() {
        try {
			return new FlexiscaleImage(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }
    
    @Override
    public FlexiscaleSnapshot getSnapshotSupport() {
        try {
			return new FlexiscaleSnapshot(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }
    
    @Override
    public FlexiscaleVirtualServer getVirtualMachineSupport() {
        try {
			return new FlexiscaleVirtualServer(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }
    
    @Override
    public FlexiscaleDisk getVolumeSupport() {
        try {
			return new FlexiscaleDisk(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }

}
