/**
 * Copyright (C) 2009-2012 enStratus Networks Inc
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.flexiscale.compute;

import java.io.Serializable;

/**
 * @author Qunying Huang @ enstratus
 * <p>
 * storage(Volume) product offers by flexiscale
 * </p>
 *
 */
@SuppressWarnings("serial")
public class FlexiscaleDiskProduct implements Serializable {
	//private static final long serialVersionUID = 1L;
	private String description;
    private int    diskSizeInGb;
    private String name;
    private long productId;
    
    public FlexiscaleDiskProduct() { }

    public boolean equals(Object ob) {
        if( ob == null) {
            return false;
        }
        if( ob == this ) {
            return true;
        }
        if( !getClass().getName().equals(ob.getClass().getName()) ) {
            return false;
        }
        return getProductId()==(((FlexiscaleDiskProduct)ob).getProductId());
    }
    
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getDiskSizeInGb() {
        return diskSizeInGb;
    }

    public void setDiskSizeInGb(int diskSizeInGb) {
        this.diskSizeInGb = diskSizeInGb;
    }

    public long getProductId() {
        return productId;
    }

    public void setProductId(long productId) {
        this.productId = productId;
    }
}