/**
 * Copyright (C) 2009-2012 enStratus Networks Inc
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.flexiscale.identity;


import org.dasein.cloud.CloudException;
import org.dasein.cloud.flexiscale.FlexiscaleProvider;
import org.dasein.cloud.identity.AbstractIdentityServices;

public class FlexiscaleIdentityServices extends AbstractIdentityServices {
    private FlexiscaleProvider cloud;
    
    public FlexiscaleIdentityServices(FlexiscaleProvider cloud) { this.cloud = cloud; }
    
    @Override
    public Keypairs getShellKeySupport() {
        try {
			return new Keypairs(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }

}
