/**
 * Copyright (C) 2009-2012 enStratus Networks Inc
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.flexiscale.network;


import org.dasein.cloud.CloudException;
import org.dasein.cloud.flexiscale.FlexiscaleProvider;
import org.dasein.cloud.network.AbstractNetworkServices;

public class FlexiscaleNetworkServices extends AbstractNetworkServices {
    private FlexiscaleProvider cloud;
    
    public FlexiscaleNetworkServices(FlexiscaleProvider cloud) { this.cloud = cloud; }

    @Override
    public FlexiscaleIP getIpAddressSupport(){
        try {
			return new FlexiscaleIP(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }
    @Override
    public FlexiscaleFirewall getFirewallSupport(){
        try {
			return new FlexiscaleFirewall(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }
    @Override
    public FlexiscaleVlan getVlanSupport(){
        try {
			return new FlexiscaleVlan(cloud);
		} catch (CloudException e) {
			e.printStackTrace();
		}
		return null;
    }
}
